#include "B4RDefines.h"
namespace B4R {
    void B4RMCPXXX::Initialize(Byte csPin,Pot pot,Resolution res,WiperConfiguration config) {
		mcp = new (sizeMCP) MCP4XXX(csPin, pot, res, config);
	}
    UInt B4RMCPXXX::getWiperRange(void) const{
        return mcp->max_value();
    }
    bool B4RMCPXXX::WiperSet(byte value) {
        return mcp->set(value);
    }
    UInt B4RMCPXXX::getWiperGet(void) const{
        return mcp->get();
    }
	bool B4RMCPXXX::WiperSetNV(byte value) {
        return mcp->setnv(value);
    }
    UInt B4RMCPXXX::getWiperGetNV(void) const{
        return mcp->getnv();
    }
    bool B4RMCPXXX::WiperIncrement(void) {
        return mcp->increment();
    }
    bool B4RMCPXXX::WiperDecrement(void) {
        return mcp->decrement();
    }
    bool B4RMCPXXX::ConnTermASet(bool connected) {
        return mcp->set_terminal_a_status(connected);
    }
    bool B4RMCPXXX::ConnTermA(void) const {
        return mcp->get_terminal_a_status();
    }
    bool B4RMCPXXX::ConnTermBSet(bool connected) {
        return mcp->set_terminal_b_status(connected);
    }
    bool B4RMCPXXX::ConnTermB(void) const {
        return mcp->get_terminal_b_status();
    }
    bool B4RMCPXXX::ConnWiperSet(bool connected) {
        return mcp->set_wiper_status(connected);
    }
    bool B4RMCPXXX::ConnWiper(void) const{
        return mcp->get_wiper_status();
    }
    bool B4RMCPXXX::ShutdownStatus(void) const{
        return mcp->get_hardware_shutdown_status();
    }
	
	// bool set_shutdown_status(bool shutdown);
    // bool get_hardware_shutdown_status(void) const;
}