#pragma once
#include "B4RDefines.h"
#include "mcp4xxx.h"
namespace B4R {
	//~Version: 1.01
	//~Shortname: MCP4xxx
    //~Author: Original Library from jmalloc
	class B4RMCPXXX {
		private:
            uint8_t sizeMCP[sizeof(MCP4XXX)];
			MCP4XXX* mcp;
		public:
            //Initialize MCP4XXX object with given CS/SS pin, pot number,
            //resolution and configuration. Should be set correctly for each 
            //chip in the MCP4XXX series as there is no error checking.
            //Refer to chip datasheet for correct setting.
            void Initialize(Byte csPin,Pot pot,Resolution res,WiperConfiguration config);
            //Return wiper range. Depends on the configuration.
            UInt getWiperRange(void) const;
            //Set the wiper position. Returns true if successful
            bool WiperSet(byte value);
            //Get the wiper position.
            UInt getWiperGet(void) const;
			//Set the non volatile wiper position. Returns true if successful
            bool WiperSetNV(byte value);
            //Get the non volatile wiper position.
            UInt getWiperGetNV(void) const;
            //Increment wiper position. Returns true if successful.
            bool WiperIncrement(void);
            //Decrement wiper position. Returns true if successful.
            bool WiperDecrement(void);
            //Get status of Terminal A connection. True if connected.
            bool ConnTermA(void) const;
            //Set connection state of Terminal A. Returns true if successful
            bool ConnTermASet(bool connected);
             //Get status of Terminal A connection. True if connected
            bool ConnTermB(void) const;
            //Set connection state of Terminal B. Returns true if successful
            bool ConnTermBSet(bool connected);
            //Get status of Wiper connection. True if connected
            bool ConnWiper(void) const;
            //Set connection state of Wiper. Returns true if successful
            bool ConnWiperSet(bool connected);
			//Get shutdown status
			bool ShutdownStatus(void) const;
            //Potentiometer 0
            Pot POT_0=pot_0;
            //Potentiometer 1
            Pot POT_1=pot_1;
            //Use for 7 bit devices
            Resolution RES7BIT=res_7bit;
            //Use for 8 bit devices
            Resolution RES8BIT=res_8bit;
            //Use device as rheostat
            WiperConfiguration RHEOSTAT=rheostat;
            //Use device as potentiometer
            WiperConfiguration POTENTIOMETER=potentiometer;
    };
}